!**** Gets the various components from the parser and prints them 
!***  out to a file again

      subroutine xmlhandler2(in,name,value,out)

      use xml_parser

      implicit none
      integer, intent(in)       :: in
      character(*), intent(in)  :: name,value
      integer, intent(out)      :: out
      integer, parameter        :: io = 11
      character(*), parameter   :: filename = 'XXXX'
      character(*), parameter   :: f = '(a)'
      logical, save             :: content = .false.
      character                 :: d


      out = 0

      select case(in)
      case(HANDLER_START_ELEMENT)
          write(io,f,advance='no') '<' // name
      case(HANDLER_END_ELEMENT)
          write(io,f,advance='no') '</' // name // '>'
      case(HANDLER_EMPTY_ELEMENT)
          write(io,f,advance='no') '/>'
      case(HANDLER_START_ATTRIBUTES)
          continue
      case(HANDLER_END_ATTRIBUTES)
          continue
      case(HANDLER_START_XML_DECLARATION)
          continue
      case(HANDLER_END_XML_DECLARATION)
          write(io,f) value
      case(HANDLER_DTD)
          write(io,f) '<!DOCTYPE ' // value // '>'
      case(HANDLER_ATTRIBUTE)
          if (index(value,'"') /= 0) then
              d = "'"
          else
              d = '"'
          endif
          write(io,f,advance='no') ' ' // name //'=' // d // value // d
      case(HANDLER_PI)
          if (content) then
              write(io,f,advance='no') '<?' // value // '>'
          else
              write(io,f) '<?' // value // '>'
          endif
      case(HANDLER_COMMENT)
          if (content) then
              write(io,f,advance='no') '<!--' // value // '-->'
          else
              write(io,f) '<!--' // value // '-->'
          endif
      case(HANDLER_CDATA)
          write(io,f,advance='no') '<![CDATA[' // value // ']]>'
      case(HANDLER_CHARDATA)
          write(io,f,advance='no') value
      case(HANDLER_REFERENCE)
          write(io,f,advance='no') '&' // value // ';'
      case(HANDLER_START_DOCUMENT)
          open(io,file=filename,recl=1000000)
      case(HANDLER_END_DOCUMENT)
          close(io)
      case(HANDLER_START_CONTENT)
          write(io,f,advance='no') '>'
      case(HANDLER_END_CONTENT)
          continue
      case(HANDLER_START_PROLOG)
          continue
      case(HANDLER_END_PROLOG)
          continue
      case(HANDLER_START_ROOT_ELEMENT)
          content = .true.
      case(HANDLER_END_ROOT_ELEMENT)
          content = .false.
      case default
          stop 'HANDLER2: unknown handler code'
      end select

      end subroutine xmlhandler2
